const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const journal_voucher_types = sequelize.define(
    'journal_voucher_types',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

code: {
        type: DataTypes.TEXT,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

requires_approval: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  journal_voucher_types.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



































    db.journal_voucher_types.hasMany(db.journal_vouchers, {
      as: 'journal_vouchers_voucher_type',
      foreignKey: {
          name: 'voucher_typeId',
      },
      constraints: false,
    });















//end loop



    db.journal_voucher_types.belongsTo(db.businesses, {
      as: 'business',
      foreignKey: {
        name: 'businessId',
      },
      constraints: false,
    });

    db.journal_voucher_types.belongsTo(db.numbering_profiles, {
      as: 'numbering_profile',
      foreignKey: {
        name: 'numbering_profileId',
      },
      constraints: false,
    });




    db.journal_voucher_types.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.journal_voucher_types.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return journal_voucher_types;
};


